com.fasterxml.jackson.databind.deser.std

## Class JsonNodeDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.JsonNodeDeserializer

All Implemented Interfaces:
  NullValueProvider, Serializable

    public class JsonNodeDeserializer
    extends StdDeserializer<T>

Deserializer that can build instances of `JsonNode` from any JSON content, using appropriate `JsonNode` type.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Boolean` `_supportsUpdates`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`protected` `JsonNodeDeserializer()`

### Method Summary

Methods
`protected JsonNode` `_fromEmbedded(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected JsonNode` `_fromFloat(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected JsonNode` `_fromInt(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected void` `_handleDuplicateField(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory, String fieldName, ObjectNode objectNode, JsonNode oldValue, JsonNode newValue)` Method called when there is a duplicate value for a field.
`JsonNode` `deserialize(JsonParser p, DeserializationContext ctxt)` Implementation that will produce types of any JSON nodes; not just one deserializer is registered to handle (in case of more specialized handler).
`protected JsonNode` `deserializeAny(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected ArrayNode` `deserializeArray(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected ObjectNode` `deserializeObject(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)` Method called to deserialize Object node instance when there is no existing node to modify.
`protected ObjectNode` `deserializeObjectAtName(JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)` Alternate deserialization method used when parser already points to first FIELD_NAME and not START_OBJECT.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`static JsonDeserializer<? extends JsonNode>` `getDeserializer(Class<?> nodeClass)` Factory method for accessing deserializer for specific node type
`JsonNode` `getNullValue(DeserializationContext ctxt)` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`Boolean` `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.
`protected JsonNode` `updateArray(JsonParser p, DeserializationContext ctxt, ArrayNode node)` Alternate deserialization method that is to update existing `ObjectNode` if possible.
`protected JsonNode` `updateObject(JsonParser p, DeserializationContext ctxt, ObjectNode node)` Alternate deserialization method that is to update existing `ObjectNode` if possible.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserialize, findBackReference, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _supportsUpdates

    protected final Boolean _supportsUpdates

### Constructor Detail

#### JsonNodeDeserializer

    protected JsonNodeDeserializer()

### Method Detail

#### getDeserializer

    public static JsonDeserializer<? extends JsonNode> getDeserializer(Class<?> nodeClass)

Factory method for accessing deserializer for specific node type

#### getNullValue

    public JsonNode getNullValue(DeserializationContext ctxt)

Description copied from class: `JsonDeserializer`
Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

Since version 2.6 (in which the context argument was added), call is expected to be made each and every time a null token needs to be handled.

Default implementation simply returns null.

Specified by:
  `getNullValue` in interface `NullValueProvider`
Overrides:
  `getNullValue` in class `JsonDeserializer<JsonNode>`

#### deserialize

    public JsonNode deserialize(JsonParser p,
                       DeserializationContext ctxt)
                         throws IOException

Implementation that will produce types of any JSON nodes; not just one deserializer is registered to handle (in case of more specialized handler). Overridden by typed sub-classes for more thorough checking

Specified by:
  `deserialize` in class `JsonDeserializer<JsonNode>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                             DeserializationContext ctxt,
                             TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<T extends JsonNode>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### isCachable

    public boolean isCachable()

Description copied from class: `JsonDeserializer`
Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

Default implementation returns false, to indicate that no caching is done.

Overrides:
  `isCachable` in class `JsonDeserializer<T extends JsonNode>`

#### supportsUpdate

    public Boolean supportsUpdate(DeserializationConfig config)

Description copied from class: `JsonDeserializer`
Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserialization construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

Default implementation returns `null` to allow explicit per-type or per-property attempts.

Overrides:
  `supportsUpdate` in class `JsonDeserializer<T extends JsonNode>`

#### _handleDuplicateField

    protected void _handleDuplicateField(JsonParser p,
                             DeserializationContext ctxt,
                             JsonNodeFactory nodeFactory,
                             String fieldName,
                             ObjectNode objectNode,
                             JsonNode oldValue,
                             JsonNode newValue)
                                  throws JsonProcessingException

Method called when there is a duplicate value for a field. By default we don't care, and the last value is used. Can be overridden to provide alternate handling, such as throwing an exception, or choosing different strategy for combining values or choosing which one to keep.

Parameters:
  `fieldName` - Name of the field for which duplicate value was found
  `objectNode` - Object node that contains values
  `oldValue` - Value that existed for the object node before newValue was added
  `newValue` - Newly added value just added to the object node
Throws:
  `JsonProcessingException`

#### deserializeObject

    protected final ObjectNode deserializeObject(JsonParser p,
                               DeserializationContext ctxt,
                               JsonNodeFactory nodeFactory)
                                          throws IOException

Method called to deserialize Object node instance when there is no existing node to modify.

Throws:
  `IOException`

#### deserializeObjectAtName

    protected final ObjectNode deserializeObjectAtName(JsonParser p,
                                     DeserializationContext ctxt,
                                     JsonNodeFactory nodeFactory)
                                                throws IOException

Alternate deserialization method used when parser already points to first FIELD_NAME and not START_OBJECT.

Throws:
  `IOException`
Since:
  2.9

#### updateObject

    protected final JsonNode updateObject(JsonParser p,
                        DeserializationContext ctxt,
                        ObjectNode node)
                                   throws IOException

Alternate deserialization method that is to update existing `ObjectNode` if possible.

Throws:
  `IOException`
Since:
  2.9

#### deserializeArray

    protected final ArrayNode deserializeArray(JsonParser p,
                             DeserializationContext ctxt,
                             JsonNodeFactory nodeFactory)
                                        throws IOException

Throws:
  `IOException`

#### updateArray

    protected final JsonNode updateArray(JsonParser p,
                       DeserializationContext ctxt,
                       ArrayNode node)
                                  throws IOException

Alternate deserialization method that is to update existing `ObjectNode` if possible.

Throws:
  `IOException`
Since:
  2.9

#### deserializeAny

    protected final JsonNode deserializeAny(JsonParser p,
                          DeserializationContext ctxt,
                          JsonNodeFactory nodeFactory)
                                     throws IOException

Throws:
  `IOException`

#### _fromInt

    protected final JsonNode _fromInt(JsonParser p,
                    DeserializationContext ctxt,
                    JsonNodeFactory nodeFactory)
                               throws IOException

Throws:
  `IOException`

#### _fromFloat

    protected final JsonNode _fromFloat(JsonParser p,
                      DeserializationContext ctxt,
                      JsonNodeFactory nodeFactory)
                                 throws IOException

Throws:
  `IOException`

#### _fromEmbedded

    protected final JsonNode _fromEmbedded(JsonParser p,
                         DeserializationContext ctxt,
                         JsonNodeFactory nodeFactory)
                                    throws IOException

Throws:
  `IOException`